function TimerService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "TimerService"; // MANDATORY

  this.schedule = false;
  this.timetable = null;
  this.scheduleOff = [];
  this.scheduleOn = [];

  this.checkTimers = function(schedule){

    if(typeof(schedule) !== "undefined" && schedule != "undefined" && schedule != undefined && schedule != null && schedule != false){
        self.schedule = null;
        self.schedule = schedule;
        self.timetable = null;
        self.timetable = schedule.timetable;
        this.scheduleOff = [];
        this.scheduleOn = [];
        //self.log(self.timetable);
        for(var x=0; x<168; x++){
          switch (true) {
            case (x >= 0 && x < 24):
              // es lunes
              if(x == 0){
                //              x, y , day, hour
                self.searchTimer(x, 167, 1, x);
              }
              else{
                //              x, y , day, hour
                self.searchTimer(x, (x-1), 1, x);
              }
              break;
            case (x >= 24 && x < 48):
              // es martes
              self.searchTimer(x, (x-1), 2, (x-24));
              break;
            case (x >= 48 && x < 72):
              // es miercoles
              self.searchTimer(x, (x-1), 3, (x-48));
              break;
            case (x >= 72 && x < 96):
              // es jueves
              self.searchTimer(x, (x-1), 4, (x-72));
              break;
            case (x >= 96 && x < 120):
              // es viernes
              self.searchTimer(x, (x-1), 5, (x-96));
              break;
            case (x >= 120 && x < 144):
              // es sabado
              self.searchTimer(x, (x-1), 6, (x-120));
              break;
            case (x >= 144 && x < 168):
              // es domingo
              self.searchTimer(x, (x-1), 0, (x-144));
              break;
          }
          if(x == 167){
            self.log(JSON.stringify(self.scheduleOn));
            self.log(JSON.stringify(self.scheduleOff))
            self.OS.calculateTimers(self.scheduleOn, self.scheduleOff);
          }
        }
    }
    else{
      //self.OS.deteleAllTimers();
      //no borrar timers... mantener los que tenga la pantalla...
      self.log("NO TIMERS IN XML")
    }
  };

  this.searchTimer = function(x, y, day, hour){
    switch (true) {
      case (self.timetable[x] == 1 && self.timetable[y] == 0):
        // programar encendido
        self.programOn(day, hour);
        break;
      case (self.timetable[x] == 1 && self.timetable[y] == 1):
        // no hacer nada -- pasar al siguiente
        break;
      case (self.timetable[x] == 0 && self.timetable[y] == 1):
        // programar apagado
        self.programOff(day, hour);
        break;
      case (self.timetable[x] == 0 && self.timetable[y] == 0):
        // no hacer nada - pasar al siguiente
        break;
    }
  };

  this.programOff = function(day, hour){
    var timer = {
      hour : hour,
      day : day
    }
    //self.log(JSON.stringify(timer));
    self.scheduleOff.push(timer);
  };

  this.programOn = function(day, hour){
    var timer = {
      hour : hour,
      day : day
    }
    //self.log(JSON.stringify(timer));
    self.scheduleOn.push(timer);
  };
}
TimerService.prototype = new BasicService();
